<html>
<head>
<title>OgreProgressiveMesh.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreProgressiveMesh.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreProgressiveMesh_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="comment">// The underlying algorithms in this class are based heavily on:</span>
<a name="l00029"></a>00029 <span class="comment">/*</span>
<a name="l00030"></a>00030 <span class="comment"> *  Progressive Mesh type Polygon Reduction Algorithm</span>
<a name="l00031"></a>00031 <span class="comment"> *  by Stan Melax (c) 1998</span>
<a name="l00032"></a>00032 <span class="comment"> */</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#ifndef __ProgressiveMesh_H_</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="preprocessor">#define __ProgressiveMesh_H_</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector2_8h.html">OgreVector2.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareVertexBuffer_8h.html">OgreHardwareVertexBuffer.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareIndexBuffer_8h.html">OgreHardwareIndexBuffer.h</a>&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderOperation_8h.html">OgreRenderOperation.h</a>&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &quot;<a class="code" href="OgreSmallVector_8h.html">OgreSmallVector.h</a>&quot;</span>
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="keyword">namespace </span>Ogre {
<a name="l00046"></a>00046 
<a name="l00053"></a>00053     <span class="keyword">class </span>Mesh;
<a name="l00054"></a>00054     <span class="keyword">class </span>SubMesh;
<a name="l00055"></a>00055     
<a name="l00056"></a><a class="code" href="classOgre_1_1BitArray.html">00056</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1BitArray.html">BitArray</a>
<a name="l00057"></a>00057     {
<a name="l00058"></a>00058     <span class="keyword">public</span>:
<a name="l00059"></a><a class="code" href="classOgre_1_1BitArray.html#a5444f885974d3ba168b1a98910485794">00059</a>         <a class="code" href="classOgre_1_1BitArray.html#a5444f885974d3ba168b1a98910485794">BitArray</a>()                  : bits_ptr(NULL) {}
<a name="l00060"></a><a class="code" href="classOgre_1_1BitArray.html#a46d4292abb4d9d97b6a7afa60d403c3f">00060</a>         <a class="code" href="classOgre_1_1BitArray.html#a46d4292abb4d9d97b6a7afa60d403c3f">BitArray</a>(<span class="keywordtype">int</span> bits_count)    : bits_ptr(NULL) { resize(bits_count); }
<a name="l00061"></a><a class="code" href="classOgre_1_1BitArray.html#a591b29ccb7277fef464fb21f2e4d6e1d">00061</a>         <a class="code" href="classOgre_1_1BitArray.html">BitArray</a>&amp; <a class="code" href="classOgre_1_1BitArray.html#a591b29ccb7277fef464fb21f2e4d6e1d">operator=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1BitArray.html">BitArray</a>&amp; ba) { bits = ba.<a class="code" href="classOgre_1_1BitArray.html#a828871a92c7a6456b207597f730acba7">bits</a>; bits_ptr = bits.size() &gt; 0 ? &amp;bits.front() : NULL; <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00062"></a>00062         
<a name="l00063"></a><a class="code" href="classOgre_1_1BitArray.html#abc3a82bfa3cb4d6babde6bd303121ef0">00063</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BitArray.html#abc3a82bfa3cb4d6babde6bd303121ef0">getBit</a>(<span class="keywordtype">size_t</span> i)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> bits_ptr[i &gt;&gt; 3] &amp; bit_mask[i &amp; 7]; }
<a name="l00064"></a><a class="code" href="classOgre_1_1BitArray.html#a49842c6e4eef8e5ff9833f24e8fe952e">00064</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1BitArray.html#a49842c6e4eef8e5ff9833f24e8fe952e">setBit</a>(<span class="keywordtype">size_t</span> i)       { bits_ptr[i &gt;&gt; 3] |= bit_mask[i &amp; 7]; }
<a name="l00065"></a><a class="code" href="classOgre_1_1BitArray.html#a0f97f0a02faff68c5e75a30acf15f25f">00065</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1BitArray.html#a0f97f0a02faff68c5e75a30acf15f25f">clearBit</a>(<span class="keywordtype">size_t</span> i)     { bits_ptr[i &gt;&gt; 3] &amp;= ~bit_mask[i &amp; 7]; }
<a name="l00066"></a><a class="code" href="classOgre_1_1BitArray.html#a730a4e876b2ff5348311a377f43ec6be">00066</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1BitArray.html#a730a4e876b2ff5348311a377f43ec6be">clearAllBits</a>()         { memset(bits_ptr, 0, bits.size()); }
<a name="l00067"></a>00067         
<a name="l00068"></a><a class="code" href="classOgre_1_1BitArray.html#a2829647f43caa200dfd6e2f88f0b937b">00068</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BitArray.html#a2829647f43caa200dfd6e2f88f0b937b">empty</a>()<span class="keyword"> const          </span>{ <span class="keywordflow">return</span> bits.empty(); }
<a name="l00069"></a><a class="code" href="classOgre_1_1BitArray.html#ac121e16caaf504fb580165e237a3ea7a">00069</a>         <span class="keywordtype">void</span> resize(<span class="keywordtype">size_t</span> bits_count)
<a name="l00070"></a>00070         {       
<a name="l00071"></a>00071             bits.resize((bits_count + 7) / 8);
<a name="l00072"></a>00072             bits_ptr = bits.size() &gt; 0 ? &amp;bits.front() : NULL;
<a name="l00073"></a>00073             clearAllBits();
<a name="l00074"></a>00074         }
<a name="l00075"></a>00075         
<a name="l00076"></a><a class="code" href="classOgre_1_1BitArray.html#a5eba413cef8acc7212f57f989dbd4eb6">00076</a>         <span class="keywordtype">size_t</span> getBitsCount()<span class="keyword"> const</span>
<a name="l00077"></a>00077 <span class="keyword">        </span>{
<a name="l00078"></a>00078             <span class="keywordtype">size_t</span> count = 0;
<a name="l00079"></a>00079             <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> *ptr = bits_ptr, *end_ptr = bits_ptr + bits.size(); ptr != end_ptr; ++ptr)
<a name="l00080"></a>00080             {
<a name="l00081"></a>00081                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> b = *ptr;
<a name="l00082"></a>00082                 count += bit_count[b &amp; 0xF] + bit_count[b &gt;&gt; 4];
<a name="l00083"></a>00083             }
<a name="l00084"></a>00084             <span class="keywordflow">return</span> count;
<a name="l00085"></a>00085         }
<a name="l00086"></a>00086         
<a name="l00087"></a>00087     <span class="keyword">private</span>:
<a name="l00088"></a><a class="code" href="classOgre_1_1BitArray.html#a44f2386aa4b0fb2299aef7eb9890caff">00088</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>*              <a class="code" href="classOgre_1_1BitArray.html#a44f2386aa4b0fb2299aef7eb9890caff">bits_ptr</a>;       <span class="comment">// it`s so performance critical, so we place raw data pointer before all other members</span>
<a name="l00089"></a><a class="code" href="classOgre_1_1BitArray.html#a828871a92c7a6456b207597f730acba7">00089</a>         <a class="code" href="structOgre_1_1vector.html">vector&lt;unsigned char&gt;::type</a> <a class="code" href="classOgre_1_1BitArray.html#a828871a92c7a6456b207597f730acba7">bits</a>;
<a name="l00090"></a>00090         
<a name="l00091"></a><a class="code" href="classOgre_1_1BitArray.html#a5151dadbb0eb9946ececfdde359b84e2">00091</a>         <span class="keyword">const</span> <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>  bit_mask[8];    <span class="comment">// = { 1, 2, 4, 8, 16, 32, 64, 128 };</span>
<a name="l00092"></a><a class="code" href="classOgre_1_1BitArray.html#af81a0b48f78d43206fd97aaf9315f716">00092</a>         <span class="keyword">const</span> <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>  bit_count[16];  <span class="comment">// = { 0, 1, 1, 2, 1, 2, 2, 3, 1, 2, 2, 3, 2, 3, 3, 4 };</span>
<a name="l00093"></a>00093     };
<a name="l00094"></a>00094     
<a name="l00108"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html">00108</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ProgressiveMesh.html" title="This class reduces the complexity of the geometry it is given.">ProgressiveMesh</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ProgMeshAlloc</a>
<a name="l00109"></a>00109     {
<a name="l00110"></a>00110     <span class="keyword">public</span>:
<a name="l00111"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#a56d884044f64c7a2a4a94ea9c6741b83">00111</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Real&gt;::type</a> <a class="code" href="classOgre_1_1ProgressiveMesh.html#a56d884044f64c7a2a4a94ea9c6741b83">LodValueList</a>;
<a name="l00112"></a>00112         
<a name="l00114"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#ac8ade932d6a3a6b24c7b7ad33c32a8e3">00114</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1ProgressiveMesh.html#ac8ade932d6a3a6b24c7b7ad33c32a8e3" title="The way to derive the quota of vertices which are reduced at each LOD.">VertexReductionQuota</a>
<a name="l00115"></a>00115         {
<a name="l00117"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#ac8ade932d6a3a6b24c7b7ad33c32a8e3a7dcdea89ce8a061d707b04b74a97a3c0">00117</a>             <a class="code" href="classOgre_1_1ProgressiveMesh.html#ac8ade932d6a3a6b24c7b7ad33c32a8e3a7dcdea89ce8a061d707b04b74a97a3c0" title="A set number of vertices are removed at each reduction.">VRQ_CONSTANT</a>,
<a name="l00119"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#ac8ade932d6a3a6b24c7b7ad33c32a8e3a8b32f463d36c939a8202f23d91c9b31c">00119</a>             <a class="code" href="classOgre_1_1ProgressiveMesh.html#ac8ade932d6a3a6b24c7b7ad33c32a8e3a8b32f463d36c939a8202f23d91c9b31c" title="A proportion of the remaining number of vertices are removed at each reduction.">VRQ_PROPORTIONAL</a>,
<a name="l00122"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#ac8ade932d6a3a6b24c7b7ad33c32a8e3a0c432ee705dbb0ec07e47c703d1c4589">00122</a>             VRQ_ERROR_COST
<a name="l00123"></a>00123         };
<a name="l00124"></a>00124 
<a name="l00125"></a>00125         
<a name="l00151"></a>00151         <span class="keyword">static</span> <span class="keywordtype">bool</span> generateLodLevels(<a class="code" href="classOgre_1_1Mesh.html">Mesh</a>* pMesh, <span class="keyword">const</span> LodValueList&amp; lodValues,
<a name="l00152"></a>00152                                       VertexReductionQuota reductionMethod, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> reductionValue);
<a name="l00153"></a>00153 
<a name="l00164"></a>00164         <span class="keyword">static</span> <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a> generateSimplifiedMesh(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName, <a class="code" href="classOgre_1_1Mesh.html">Mesh</a>* inMesh,
<a name="l00165"></a>00165                                               <span class="keywordtype">bool</span> dropOriginalGeometry, <span class="keyword">const</span> LodValueList&amp; lodValues,
<a name="l00166"></a>00166                                               VertexReductionQuota reductionMethod, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> reductionValue,
<a name="l00167"></a>00167                                               <span class="keywordtype">size_t</span>* removedVertexDuplicatesCount);
<a name="l00168"></a>00168     <span class="keyword">protected</span>:
<a name="l00169"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#a3b9a4827741b4e7d1df8ef68882b5f33">00169</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">vector&lt;ProgressiveMesh*&gt;::type</a> <a class="code" href="classOgre_1_1ProgressiveMesh.html#a3b9a4827741b4e7d1df8ef68882b5f33">ProgressiveMeshList</a>;
<a name="l00170"></a>00170 
<a name="l00172"></a>00172         <span class="keyword">static</span> <span class="keywordtype">void</span> initializeProgressiveMeshList(<a class="code" href="classOgre_1_1ProgressiveMesh.html#a3b9a4827741b4e7d1df8ef68882b5f33">ProgressiveMeshList</a>&amp; pmList, <a class="code" href="classOgre_1_1Mesh.html">Mesh</a>* pMesh);
<a name="l00173"></a>00173 
<a name="l00175"></a>00175         <span class="keyword">static</span> <span class="keywordtype">void</span> freeProgressiveMeshList(<a class="code" href="classOgre_1_1ProgressiveMesh.html#a3b9a4827741b4e7d1df8ef68882b5f33">ProgressiveMeshList</a>* pmList);
<a name="l00176"></a>00176 
<a name="l00184"></a>00184         <a class="code" href="classOgre_1_1ProgressiveMesh.html" title="This class reduces the complexity of the geometry it is given.">ProgressiveMesh</a>(<a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* pSubMesh);
<a name="l00185"></a>00185         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1ProgressiveMesh.html" title="This class reduces the complexity of the geometry it is given.">ProgressiveMesh</a>();
<a name="l00186"></a>00186 
<a name="l00202"></a>00202         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addExtraVertexPositionBuffer(<span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* vertexData);
<a name="l00203"></a>00203 
<a name="l00212"></a>00212         <span class="keyword">static</span> <span class="keywordtype">bool</span> build(<a class="code" href="classOgre_1_1ProgressiveMesh.html#a3b9a4827741b4e7d1df8ef68882b5f33">ProgressiveMeshList</a>&amp; pmInList,
<a name="l00213"></a>00213                           <span class="keyword">const</span> <a class="code" href="classOgre_1_1LodStrategy.html" title="Strategy for determining level of detail.">LodStrategy</a> *lodStrategy, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ProgressiveMesh.html#a56d884044f64c7a2a4a94ea9c6741b83">LodValueList</a>&amp; lodValues,
<a name="l00214"></a>00214                           <a class="code" href="classOgre_1_1ProgressiveMesh.html#ac8ade932d6a3a6b24c7b7ad33c32a8e3" title="The way to derive the quota of vertices which are reduced at each LOD.">VertexReductionQuota</a> quota, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> reductionValue = 0.5f);
<a name="l00215"></a>00215                         
<a name="l00216"></a>00216     <span class="keyword">protected</span>:
<a name="l00218"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#ac7041ffc68ed4913a599d0d3f48560c6">00218</a>         <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* <a class="code" href="classOgre_1_1ProgressiveMesh.html#ac7041ffc68ed4913a599d0d3f48560c6" title="Can be NULL for non-indexed subMeshes, such PM would be skipped.">mSubMesh</a>;
<a name="l00219"></a>00219         
<a name="l00220"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#a9c68dee25ed82e1dd27c6e07b9bf6b7d">00220</a>         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> *<a class="code" href="classOgre_1_1ProgressiveMesh.html#a9c68dee25ed82e1dd27c6e07b9bf6b7d">mVertexData</a>;
<a name="l00221"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#ae527ca544184642648b2a4398a4d7813">00221</a>         <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a> *<a class="code" href="classOgre_1_1ProgressiveMesh.html#ae527ca544184642648b2a4398a4d7813">mIndexData</a>;
<a name="l00222"></a>00222 
<a name="l00223"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#ac1770d29a7b19439f7060c3a2fe0d533">00223</a>         <a class="code" href="structOgre_1_1vector.html">vector&lt;IndexData*&gt;::type</a> <a class="code" href="classOgre_1_1ProgressiveMesh.html#ac1770d29a7b19439f7060c3a2fe0d533">mLodFaceList</a>;
<a name="l00224"></a>00224         
<a name="l00225"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#a9433a872d6f450d94c9ef1a4dfe4bb72">00225</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1ProgressiveMesh.html#a9433a872d6f450d94c9ef1a4dfe4bb72">mRemovedVertexDuplicatesCount</a>;   
<a name="l00226"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#ab166495b3a0dc8f25d25485fa11dac0e">00226</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1ProgressiveMesh.html#ab166495b3a0dc8f25d25485fa11dac0e">mCurrNumIndexes</a>;
<a name="l00227"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#abfca23cf02dbe88f5d1559991fa515e3">00227</a>         <span class="keywordtype">float</span> <a class="code" href="classOgre_1_1ProgressiveMesh.html#abfca23cf02dbe88f5d1559991fa515e3">mInvSquaredBoundBoxDiagonal</a>;
<a name="l00228"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#af2fb51c4436f8f97c2c71c568c3d396d">00228</a>         <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1ProgressiveMesh.html#af2fb51c4436f8f97c2c71c568c3d396d">mVertexComponentFlags</a>;  
<a name="l00229"></a>00229 
<a name="l00230"></a>00230         <span class="comment">// Internal classes</span>
<a name="l00231"></a>00231         <span class="keyword">class </span><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html" title="A triangle in the progressive mesh, holds extra info like face normal.">PMTriangle</a>;
<a name="l00232"></a>00232         <span class="keyword">class </span><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a>;
<a name="l00233"></a>00233         <span class="keyword">struct </span>vertexLess;
<a name="l00234"></a>00234 
<a name="l00235"></a>00235     <span class="keyword">public</span>: <span class="comment">// VC6 hack</span>
<a name="l00236"></a>00236 
<a name="l00239"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html">00239</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#af4c2f5df97e3050dd5266408be42db4b">_OgrePrivate</a> <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html" title="A vertex as used by a face.">PMFaceVertex</a> {
<a name="l00240"></a>00240         <span class="keyword">public</span>:
<a name="l00241"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html#a25c686e910e4c1a9bba1e1305aba04ec">00241</a>             <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html#a25c686e910e4c1a9bba1e1305aba04ec">realIndex</a>;
<a name="l00242"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html#a0a498b8308e398baa49442f458f7acd5">00242</a>             <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a>* <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html#a0a498b8308e398baa49442f458f7acd5">commonVertex</a>;
<a name="l00243"></a>00243         };
<a name="l00244"></a>00244 
<a name="l00245"></a>00245     <span class="keyword">protected</span>:
<a name="l00246"></a>00246 
<a name="l00248"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html">00248</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#af4c2f5df97e3050dd5266408be42db4b">_OgrePrivate</a> <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html" title="A triangle in the progressive mesh, holds extra info like face normal.">PMTriangle</a> {
<a name="l00249"></a>00249         <span class="keyword">public</span>:
<a name="l00250"></a>00250             <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html" title="A triangle in the progressive mesh, holds extra info like face normal.">PMTriangle</a>();
<a name="l00251"></a>00251             <span class="keywordtype">void</span> setDetails(<span class="keywordtype">size_t</span> index, <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html" title="A vertex as used by a face.">PMFaceVertex</a> *v0, <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html" title="A vertex as used by a face.">PMFaceVertex</a> *v1, <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html" title="A vertex as used by a face.">PMFaceVertex</a> *v2);
<a name="l00252"></a>00252             <span class="keywordtype">void</span> computeNormal(<span class="keywordtype">void</span>);
<a name="l00253"></a>00253             <span class="keywordtype">void</span> replaceVertex(<a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html" title="A vertex as used by a face.">PMFaceVertex</a> *vold, <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html" title="A vertex as used by a face.">PMFaceVertex</a> *vnew);
<a name="l00254"></a>00254             <span class="keywordtype">bool</span> hasCommonVertex(<a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a> *v) <span class="keyword">const</span>;
<a name="l00255"></a>00255             <span class="keywordtype">bool</span> hasFaceVertex(<a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html" title="A vertex as used by a face.">PMFaceVertex</a> *v) <span class="keyword">const</span>;
<a name="l00256"></a>00256             <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html" title="A vertex as used by a face.">PMFaceVertex</a>* getFaceVertexFromCommon(<a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a>* commonVert);
<a name="l00257"></a>00257             <span class="keywordtype">void</span> notifyRemoved(<span class="keywordtype">void</span>);
<a name="l00258"></a>00258 
<a name="l00259"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html#ae1ae521198beb805fa9e29135898c9f7">00259</a>             <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html" title="A vertex as used by a face.">PMFaceVertex</a>*   vertex[3];  <span class="comment">// the 3 points that make this tri</span>
<a name="l00260"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html#a2965fa7602c835772a2737c9fb5c5854">00260</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>         <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html#a2965fa7602c835772a2737c9fb5c5854">normal</a>;     <span class="comment">// unit vector orthogonal to this face</span>
<a name="l00261"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html#a4fd5dea3523aee59efa13af736db4182">00261</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>            <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html#a4fd5dea3523aee59efa13af736db4182">area</a>;
<a name="l00262"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html#a5213866374d631850c409eabcbd94fb3">00262</a>             <span class="keywordtype">bool</span>            <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html#a5213866374d631850c409eabcbd94fb3">removed</a>;    <span class="comment">// true if this tri is now removed</span>
<a name="l00263"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html#a03f366aaa28888aa806556d2bb44e33a">00263</a>             <span class="keywordtype">size_t</span>          <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html#a03f366aaa28888aa806556d2bb44e33a">index</a>;
<a name="l00264"></a>00264         };
<a name="l00265"></a>00265 
<a name="l00272"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html">00272</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#af4c2f5df97e3050dd5266408be42db4b">_OgrePrivate</a> <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a> {
<a name="l00273"></a>00273         <span class="keyword">public</span>:
<a name="l00274"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#aea49c75299926625a8ddb468463c0f3ea2a8dcf807b6f977d45d983a1080be6df">00274</a>             <span class="keyword">enum</span> <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#aea49c75299926625a8ddb468463c0f3e">BorderStatus</a> { BS_UNKNOWN = 0, BS_NOT_BORDER, BS_BORDER };
<a name="l00275"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a83a98e0ed483ecb9b27e76a8015c41ed">00275</a>             <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SmallVector.html">SmallVector&lt;PMVertex *, 8&gt;</a> <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a83a98e0ed483ecb9b27e76a8015c41ed">NeighborList</a>;
<a name="l00276"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a3a99524de875faec7b675674cb39bbea">00276</a>             <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SmallVector.html">SmallVector&lt;PMTriangle *, 8&gt;</a> <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a3a99524de875faec7b675674cb39bbea">FaceList</a>;
<a name="l00277"></a>00277 
<a name="l00278"></a>00278         <span class="keyword">public</span>:
<a name="l00279"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a4c52cc21daf3d06a39b04c1f125b8577">00279</a>             <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a4c52cc21daf3d06a39b04c1f125b8577">PMVertex</a>() : mBorderStatus(BS_UNKNOWN), removed(false) {}
<a name="l00280"></a>00280 
<a name="l00281"></a>00281             <span class="keywordtype">void</span> setDetails(<span class="keywordtype">size_t</span> index, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; pos, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; normal, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; uv);
<a name="l00282"></a>00282         
<a name="l00283"></a>00283             <span class="keywordtype">bool</span> isNearEnough(<a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a>* other) <span class="keyword">const</span>;
<a name="l00284"></a>00284             <span class="keywordtype">void</span> removeIfNonNeighbor(<a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a> *n);
<a name="l00285"></a>00285             <span class="keywordtype">void</span> initBorderStatus(<span class="keywordtype">void</span>);
<a name="l00286"></a>00286             <span class="keywordtype">bool</span> isManifoldEdgeWith(<a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a>* v); <span class="comment">// is edge this-&gt;src a manifold edge?</span>
<a name="l00287"></a>00287             <span class="keywordtype">void</span> notifyRemoved(<span class="keywordtype">void</span>);
<a name="l00288"></a>00288             <span class="keywordtype">void</span> calculateNormal();
<a name="l00289"></a>00289         
<a name="l00290"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#ab2c1e1bf8296736b1b426577cdd8a020">00290</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#ab2c1e1bf8296736b1b426577cdd8a020">position</a>;  <span class="comment">// location of point in euclidean space</span>
<a name="l00291"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#ad3a7a5f290ac61eef6d8f180fad0db03">00291</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#ad3a7a5f290ac61eef6d8f180fad0db03">normal</a>;
<a name="l00292"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a078f3662efed050eced0e84356d8a868">00292</a>             <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a078f3662efed050eced0e84356d8a868">uv</a>;
<a name="l00293"></a>00293             
<a name="l00294"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a6982e31f211ee8b10cf643baebefc3aa">00294</a>             <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a6982e31f211ee8b10cf643baebefc3aa">index</a>;       <span class="comment">// place of vertex in original list</span>
<a name="l00295"></a>00295 
<a name="l00296"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a5d9e4494654cd43aebad3d618193797e">00296</a>             <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#aea49c75299926625a8ddb468463c0f3e">BorderStatus</a> <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a5d9e4494654cd43aebad3d618193797e">mBorderStatus</a>;         
<a name="l00297"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a75bbec5fa218bb9845b3f059b9cddab6">00297</a>             <span class="keywordtype">bool</span>      <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a75bbec5fa218bb9845b3f059b9cddab6">removed</a>;   <span class="comment">// true if this vert is now removed</span>
<a name="l00298"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#ad259bc95f91a0186b62d932d368bde57">00298</a>             <span class="keywordtype">bool</span>      <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#ad259bc95f91a0186b62d932d368bde57">toBeRemoved</a>; <span class="comment">// debug</span>
<a name="l00299"></a>00299 
<a name="l00300"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a0bcc94cc31dc57068026c7a185baa589">00300</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a0bcc94cc31dc57068026c7a185baa589">collapseCost</a>;  <span class="comment">// cached cost of collapsing edge</span>
<a name="l00301"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a63fb8662dd40d265518a2c434e1e400b">00301</a>             <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a> * <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a63fb8662dd40d265518a2c434e1e400b">collapseTo</a>; <span class="comment">// candidate vertex for collapse</span>
<a name="l00302"></a>00302             
<a name="l00303"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#aba08b3a1f6c6618e71fca01f4c326684">00303</a>             <a class="code" href="classOgre_1_1SmallVector.html">NeighborList</a> <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#aba08b3a1f6c6618e71fca01f4c326684">neighbor</a>; <span class="comment">// adjacent vertices</span>
<a name="l00304"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a47b4d3d779f9e5323a24f53cf613a490">00304</a>             <a class="code" href="classOgre_1_1SmallVector.html">FaceList</a> <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#a47b4d3d779f9e5323a24f53cf613a490">face</a>;     <span class="comment">// adjacent triangles</span>
<a name="l00305"></a>00305         };
<a name="l00306"></a>00306         
<a name="l00307"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#a1963ffe016281bb57bb80496590a0e43">00307</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;PMTriangle&gt;::type</a> <a class="code" href="classOgre_1_1ProgressiveMesh.html#a1963ffe016281bb57bb80496590a0e43">TriangleList</a>;
<a name="l00308"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#a9a9fc6707e2c033f44ac650cb8bcebc7">00308</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;PMFaceVertex&gt;::type</a> <a class="code" href="classOgre_1_1ProgressiveMesh.html#a9a9fc6707e2c033f44ac650cb8bcebc7">FaceVertexList</a>;
<a name="l00309"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#a60e89e17d387bd0aa93608a1068f9d42">00309</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;PMVertex&gt;::type</a> <a class="code" href="classOgre_1_1ProgressiveMesh.html#a60e89e17d387bd0aa93608a1068f9d42">CommonVertexList</a>;
<a name="l00310"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#ab1577fa4926f946eef7bafbbc9ed51c0">00310</a>         <span class="keyword">typedef</span> std::pair&lt;Real, unsigned int&gt; <a class="code" href="classOgre_1_1ProgressiveMesh.html#ab1577fa4926f946eef7bafbbc9ed51c0">CostIndexPair</a>;
<a name="l00311"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#a623b1b831017164d23e7a6d58acef921">00311</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;CostIndexPair&gt;::type</a> <a class="code" href="classOgre_1_1ProgressiveMesh.html#a623b1b831017164d23e7a6d58acef921">WorstCostList</a>;
<a name="l00312"></a>00312 
<a name="l00314"></a><a class="code" href="structOgre_1_1ProgressiveMesh_1_1PMWorkingData.html">00314</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1ProgressiveMesh_1_1PMWorkingData.html" title="Data used to calculate the collapse costs.">PMWorkingData</a>
<a name="l00315"></a>00315         {
<a name="l00316"></a><a class="code" href="structOgre_1_1ProgressiveMesh_1_1PMWorkingData.html#abc95718fbe89b15ac1dabdcbfc19cd56">00316</a>             <a class="code" href="classOgre_1_1ProgressiveMesh.html#a1963ffe016281bb57bb80496590a0e43">TriangleList</a> <a class="code" href="structOgre_1_1ProgressiveMesh_1_1PMWorkingData.html#abc95718fbe89b15ac1dabdcbfc19cd56">mTriList</a>; 
<a name="l00317"></a><a class="code" href="structOgre_1_1ProgressiveMesh_1_1PMWorkingData.html#ae86f7159118c6ed73b2aef36c9aec3c0">00317</a>             <a class="code" href="classOgre_1_1ProgressiveMesh.html#a9a9fc6707e2c033f44ac650cb8bcebc7">FaceVertexList</a> <a class="code" href="structOgre_1_1ProgressiveMesh_1_1PMWorkingData.html#ae86f7159118c6ed73b2aef36c9aec3c0" title="List of faces.">mFaceVertList</a>; <span class="comment">// The vertex details referenced by the triangles</span>
<a name="l00318"></a><a class="code" href="structOgre_1_1ProgressiveMesh_1_1PMWorkingData.html#a69bbfe9ac518ca8c9519c6de8673f8f3">00318</a>             <a class="code" href="classOgre_1_1ProgressiveMesh.html#a60e89e17d387bd0aa93608a1068f9d42">CommonVertexList</a> <a class="code" href="structOgre_1_1ProgressiveMesh_1_1PMWorkingData.html#a69bbfe9ac518ca8c9519c6de8673f8f3">mVertList</a>; <span class="comment">// The master list of common vertices</span>
<a name="l00319"></a>00319         };
<a name="l00320"></a>00320 
<a name="l00321"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#af6fca25fdbbbb18621e40f4f95272b1d">00321</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;PMWorkingData&gt;::type</a> <a class="code" href="classOgre_1_1ProgressiveMesh.html#af6fca25fdbbbb18621e40f4f95272b1d">WorkingDataList</a>;
<a name="l00323"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#ad657f9004aabb5932753a429061b8ed7">00323</a>         <a class="code" href="classOgre_1_1ProgressiveMesh.html#af6fca25fdbbbb18621e40f4f95272b1d">WorkingDataList</a> <a class="code" href="classOgre_1_1ProgressiveMesh.html#ad657f9004aabb5932753a429061b8ed7" title="Multiple copies, 1 per vertex buffer.">mWorkingData</a>;
<a name="l00324"></a>00324 
<a name="l00326"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#aefa2fb879e0989999c893e51c529d414">00326</a>         <a class="code" href="classOgre_1_1ProgressiveMesh.html#a623b1b831017164d23e7a6d58acef921">WorstCostList</a>   <a class="code" href="classOgre_1_1ProgressiveMesh.html#aefa2fb879e0989999c893e51c529d414" title="The worst collapse cost from all vertex buffers for each vertex.">mWorstCosts</a>;        <span class="comment">// sorted by cost, but some of entries are invalidated, so check invalidCostMask</span>
<a name="l00327"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#a3bcef94f466cdec0a5771a1b9ddf97eb">00327</a>         <a class="code" href="classOgre_1_1BitArray.html">BitArray</a>        <a class="code" href="classOgre_1_1ProgressiveMesh.html#a3bcef94f466cdec0a5771a1b9ddf97eb">mInvalidCostMask</a>;   <span class="comment">// indexed by vertex index</span>
<a name="l00328"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#a9984bd5f5413c7812b6f3f456cffdb82">00328</a>         <span class="keywordtype">size_t</span>          <a class="code" href="classOgre_1_1ProgressiveMesh.html#a9984bd5f5413c7812b6f3f456cffdb82">mInvalidCostCount</a>;
<a name="l00329"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#a1a9adf7e925259106cc24b5abbb6d9be">00329</a>         <span class="keywordtype">size_t</span>          <a class="code" href="classOgre_1_1ProgressiveMesh.html#a1a9adf7e925259106cc24b5abbb6d9be">mWorstCostsSize</a>;
<a name="l00330"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#a123d6c2f73cf860130c5f0546809a6b0">00330</a>         <span class="keywordtype">size_t</span>          <a class="code" href="classOgre_1_1ProgressiveMesh.html#a123d6c2f73cf860130c5f0546809a6b0">mNextWorstCostHint</a>; <span class="comment">// getNextCollapser() uses it to reduce complexity from O(n^2) to O(n)</span>
<a name="l00331"></a>00331             
<a name="l00333"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#acd0e386e078e142fd78194acda14def3">00333</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1SmallVector.html">PMVertex::FaceList</a> <a class="code" href="classOgre_1_1ProgressiveMesh.html#acd0e386e078e142fd78194acda14def3" title="Temporary variable used in computeEdgeCollapseCost, declared here to avoid multiple memory allocation...">mEdgeAdjacentSides</a>;
<a name="l00334"></a>00334 
<a name="l00336"></a>00336         <span class="keywordtype">void</span> addWorkingData(<span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* vertexData, <span class="keyword">const</span> <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* indexData);
<a name="l00337"></a>00337         <span class="keywordtype">void</span> mergeWorkingDataBorders();
<a name="l00338"></a>00338         
<a name="l00340"></a>00340         <span class="keywordtype">void</span> initialiseEdgeCollapseCosts(<span class="keywordtype">void</span>);
<a name="l00342"></a>00342         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> computeEdgeCollapseCost(<a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a> *src, <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a> *dest) <span class="keyword">const</span>;
<a name="l00344"></a>00344         <span class="keywordtype">bool</span> collapseInvertsNormals(<a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a> *src, <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a> *dest) <span class="keyword">const</span>;
<a name="l00346"></a>00346         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> computeEdgeCostAtVertexForBuffer(<a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a>* v);
<a name="l00348"></a>00348         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> computeEdgeCostAtVertex(<span class="keywordtype">size_t</span> vertIndex);
<a name="l00350"></a>00350         <span class="keywordtype">void</span> computeAllCosts(<span class="keywordtype">void</span>);
<a name="l00351"></a>00351 
<a name="l00353"></a>00353         <span class="keyword">static</span> <span class="keywordtype">size_t</span> getInvalidCostCount(<a class="code" href="classOgre_1_1ProgressiveMesh.html#a3b9a4827741b4e7d1df8ef68882b5f33">ProgressiveMesh::ProgressiveMeshList</a>&amp; pmList);
<a name="l00354"></a>00354         <span class="keyword">static</span> <span class="keywordtype">bool</span> recomputeInvalidCosts(<a class="code" href="classOgre_1_1ProgressiveMesh.html#a3b9a4827741b4e7d1df8ef68882b5f33">ProgressiveMeshList</a>&amp; pmInList);
<a name="l00355"></a>00355         <span class="keywordtype">void</span> recomputeInvalidCosts();
<a name="l00356"></a>00356         <span class="keywordtype">void</span> sortIndexesByCost();
<a name="l00357"></a>00357         <span class="keyword">static</span> <span class="keywordtype">int</span> cmpByCost(<span class="keyword">const</span> <span class="keywordtype">void</span>* p1, <span class="keyword">const</span> <span class="keywordtype">void</span>* p2); <span class="comment">// comparator for mWorstCosts sorting</span>
<a name="l00358"></a>00358         
<a name="l00360"></a>00360         <span class="keyword">static</span> <span class="keywordtype">void</span> getNextCollapser(<a class="code" href="classOgre_1_1ProgressiveMesh.html#a3b9a4827741b4e7d1df8ef68882b5f33">ProgressiveMeshList</a>&amp; pmList, <a class="code" href="classOgre_1_1ProgressiveMesh.html" title="This class reduces the complexity of the geometry it is given.">ProgressiveMesh</a>*&amp; pm, <a class="code" href="classOgre_1_1ProgressiveMesh.html#ab1577fa4926f946eef7bafbbc9ed51c0">CostIndexPair</a>*&amp; bestCollapser);
<a name="l00361"></a>00361         <a class="code" href="classOgre_1_1ProgressiveMesh.html#ab1577fa4926f946eef7bafbbc9ed51c0">CostIndexPair</a>* getNextCollapser();
<a name="l00362"></a>00362         
<a name="l00364"></a>00364         <span class="keywordtype">void</span> bakeNewLOD(<a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* pData);
<a name="l00366"></a>00366         <span class="keyword">static</span> <span class="keywordtype">void</span> bakeLodUsage(<a class="code" href="classOgre_1_1Mesh.html">Mesh</a>* pMesh, <a class="code" href="classOgre_1_1LodStrategy.html" title="Strategy for determining level of detail.">LodStrategy</a> *lodStrategy, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ProgressiveMesh.html#a56d884044f64c7a2a4a94ea9c6741b83">LodValueList</a>&amp; lodValues, <span class="keywordtype">bool</span> skipFirstLodLevel = <span class="keyword">false</span>);
<a name="l00367"></a>00367 
<a name="l00374"></a>00374         <span class="keywordtype">void</span> collapse(<a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a> *collapser);
<a name="l00375"></a>00375 
<a name="l00377"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#a2ead62fe5344ec3acf8938e7ca3b57b8">00377</a>         <span class="keyword">typedef</span> std::pair&lt;unsigned, PMVertex*&gt; <a class="code" href="classOgre_1_1ProgressiveMesh.html#a2ead62fe5344ec3acf8938e7ca3b57b8" title="We can defragment mesh, removing unused vertices and re-indexing other, storing old-to-new mapping in...">IndexVertexPair</a>;
<a name="l00379"></a>00379         <span class="keyword">static</span> <span class="keywordtype">void</span> bakeSimplifiedMesh(<a class="code" href="classOgre_1_1Mesh.html">Mesh</a>* destMesh, <a class="code" href="classOgre_1_1Mesh.html">Mesh</a>* srcMesh, <a class="code" href="classOgre_1_1ProgressiveMesh.html#a3b9a4827741b4e7d1df8ef68882b5f33">ProgressiveMeshList</a>&amp; pmList, <span class="keywordtype">bool</span> dropFirstLodLevel = <span class="keyword">false</span>);
<a name="l00381"></a>00381         <span class="keyword">static</span> <span class="keywordtype">void</span> createSimplifiedVertexData(<a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">vector&lt;IndexVertexPair&gt;::type</a>&amp; usedVertices, <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* inVData, <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>*&amp; outVData, <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; aabox);
<a name="l00383"></a>00383         <span class="keyword">static</span> <span class="keywordtype">void</span> createIndexMap(<a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">vector&lt;IndexVertexPair&gt;::type</a>&amp; usedVertices, <span class="keywordtype">unsigned</span> allVertexCount, <a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">vector&lt;unsigned&gt;::type</a>&amp; indexMap);
<a name="l00384"></a>00384         
<a name="l00386"></a>00386         <span class="keywordtype">void</span> dumpContents(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; log);
<a name="l00387"></a>00387     };
<a name="l00388"></a>00388             
<a name="l00389"></a><a class="code" href="structOgre_1_1HardwareBufferLockGuard.html">00389</a>     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">struct </span><a class="code" href="structOgre_1_1HardwareBufferLockGuard.html">HardwareBufferLockGuard</a>
<a name="l00390"></a>00390     {
<a name="l00391"></a><a class="code" href="structOgre_1_1HardwareBufferLockGuard.html#ad9271b5aad5231370b381f585a5731a8">00391</a>         <a class="code" href="structOgre_1_1HardwareBufferLockGuard.html#ad9271b5aad5231370b381f585a5731a8">HardwareBufferLockGuard</a>(<span class="keyword">const</span> T&amp; p, <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">HardwareBuffer::LockOptions</a> options)
<a name="l00392"></a>00392         : <a class="code" href="structOgre_1_1HardwareBufferLockGuard.html#a9bc4d578f99874bc5ca0db0919e0cdf3">pBuf</a>(p)
<a name="l00393"></a>00393         {
<a name="l00394"></a>00394             <a class="code" href="structOgre_1_1HardwareBufferLockGuard.html#afbd3bce916b40348121ab6de764238b2">pData</a> = <a class="code" href="structOgre_1_1HardwareBufferLockGuard.html#a9bc4d578f99874bc5ca0db0919e0cdf3">pBuf</a>-&gt;lock(options);
<a name="l00395"></a>00395         }
<a name="l00396"></a><a class="code" href="structOgre_1_1HardwareBufferLockGuard.html#a1fb4fde0b732d3514560e04b0c879586">00396</a>         <a class="code" href="structOgre_1_1HardwareBufferLockGuard.html#ad9271b5aad5231370b381f585a5731a8">HardwareBufferLockGuard</a>(<span class="keyword">const</span> T&amp; p, <span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">HardwareBuffer::LockOptions</a> options)
<a name="l00397"></a>00397         : <a class="code" href="structOgre_1_1HardwareBufferLockGuard.html#a9bc4d578f99874bc5ca0db0919e0cdf3">pBuf</a>(p)
<a name="l00398"></a>00398         {
<a name="l00399"></a>00399             <a class="code" href="structOgre_1_1HardwareBufferLockGuard.html#afbd3bce916b40348121ab6de764238b2">pData</a> = <a class="code" href="structOgre_1_1HardwareBufferLockGuard.html#a9bc4d578f99874bc5ca0db0919e0cdf3">pBuf</a>-&gt;lock(offset, length, options);
<a name="l00400"></a>00400         }       
<a name="l00401"></a><a class="code" href="structOgre_1_1HardwareBufferLockGuard.html#a318992da74bc1a839fec5d3fc58c57db">00401</a>         <a class="code" href="structOgre_1_1HardwareBufferLockGuard.html#a318992da74bc1a839fec5d3fc58c57db">~HardwareBufferLockGuard</a>()
<a name="l00402"></a>00402         {
<a name="l00403"></a>00403             <a class="code" href="structOgre_1_1HardwareBufferLockGuard.html#a9bc4d578f99874bc5ca0db0919e0cdf3">pBuf</a>-&gt;unlock();
<a name="l00404"></a>00404         }
<a name="l00405"></a><a class="code" href="structOgre_1_1HardwareBufferLockGuard.html#a9bc4d578f99874bc5ca0db0919e0cdf3">00405</a>         <span class="keyword">const</span> T&amp; <a class="code" href="structOgre_1_1HardwareBufferLockGuard.html#a9bc4d578f99874bc5ca0db0919e0cdf3">pBuf</a>;
<a name="l00406"></a><a class="code" href="structOgre_1_1HardwareBufferLockGuard.html#afbd3bce916b40348121ab6de764238b2">00406</a>         <span class="keywordtype">void</span>* <a class="code" href="structOgre_1_1HardwareBufferLockGuard.html#afbd3bce916b40348121ab6de764238b2">pData</a>;
<a name="l00407"></a>00407     };
<a name="l00408"></a>00408     
<a name="l00409"></a><a class="code" href="group__LOD.html#gab97b2e1a8ca761f39bc66875f1637dc9">00409</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1HardwareBufferLockGuard.html">HardwareBufferLockGuard&lt;HardwareVertexBufferSharedPtr&gt;</a> <a class="code" href="group__LOD.html#gab97b2e1a8ca761f39bc66875f1637dc9">VertexBufferLockGuard</a>;
<a name="l00410"></a><a class="code" href="group__LOD.html#ga13e9b503047c41c3b984d1722d7a85c2">00410</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1HardwareBufferLockGuard.html">HardwareBufferLockGuard&lt;HardwareIndexBufferSharedPtr&gt;</a> <a class="code" href="group__LOD.html#ga13e9b503047c41c3b984d1722d7a85c2">IndexBufferLockGuard</a>;
<a name="l00411"></a>00411     
<a name="l00414"></a>00414 }
<a name="l00415"></a>00415 
<a name="l00416"></a>00416 <span class="preprocessor">#endif </span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
